'''
实验名称：MQTT通信
版本：v1.0
日期：2021.8
作者：01Studio
说明：编程实现MQTT通信，实现订阅（接收）数据。
MQTT助手：http://www.tongxinmao.com/txm/webmqtt.php#collapseOne
'''
import network,time
from simple import MQTTClient #导入MQTT板块
from machine import I2C,Pin,Timer,SoftI2C
import ssd1306


# 创建i2c对象
i2c = SoftI2C(scl=Pin(20), sda=Pin(19))

# 宽度高度
oled_width = 128
oled_height = 64

# 创建oled屏幕对象
oled = ssd1306.SSD1306_I2C(oled_width, oled_height, i2c)

# 在指定位置处显示文字

oled.text('this is:', 0, 10)
oled.text('C6-B', 0, 25)
oled.text('RECEIVER', 0, 40)
        
oled.show()


WIFI_LED=Pin(15, Pin.OUT) #初始化WIFI指示灯
#WIFI连接函数


def WIFI_Connect():

    WIFI_LED=Pin(15, Pin.OUT) #初始化WIFI指示灯

    wlan = network.WLAN(network.STA_IF) #STA模式
    wlan.active(True)                   #激活接口
    start_time=time.time()              #记录时间做超时判断

    if not wlan.isconnected():
        print('connecting to network...')
        wlan.connect('wifiname', 'wifipassword') #输入WIFI账号密码

        while not wlan.isconnected():

            #LED闪烁提示
            WIFI_LED.value(1)
            time.sleep_ms(300)
            WIFI_LED.value(0)
            time.sleep_ms(300)

            #超时判断,15秒没连接成功判定为超时
            if time.time()-start_time > 15 :
                print('WIFI Connected Timeout!')
                break

    if wlan.isconnected():
        #LED点亮
        WIFI_LED.value(1)

        #串口打印信息
        print('network information:', wlan.ifconfig())


        return True

    else:
        return False

def fill_screen(color):  
    # 直接将颜色值传递给fill方法，而不是传递一个缓冲区  
    oled.fill(color)  
    oled.show()  


#接收数据任务
def MQTT_Rev(TOPIC,msg):
    client.check_msg()   #获得TOPIC和msg
    print(msg)
    
    if msg==b'True':
       WIFI_LED.value(0)
       print("off")
       # 全屏白色（通常是255，但具体值取决于屏幕的颜色编码）  
       fill_screen(1)


    elif msg==b'False':
       WIFI_LED.value(1)
       print("on")
       # 全屏黑色（通常是0）  
       fill_screen(0) 


   


#执行WIFI连接函数并判断是否已经连接成功
if WIFI_Connect():

    SERVER = 'mq.tongxinmao.com'
    PORT = 18830
    CLIENT_ID = '01Studio-ESP832-B' # 客户端ID
    TOPIC = '/public/01Studio/1' # TOPIC名称

    client = MQTTClient(CLIENT_ID, SERVER, PORT) #建立客户端对象
    client.set_callback(MQTT_Rev)  #配置回调函数
    client.connect()
    client.subscribe(TOPIC) #订阅主题

msg=b""



while True:
    MQTT_Rev(TOPIC,msg)
    time.sleep(1)
